﻿// ОПИСАНИЕ: Скрипт для InDesign CS3
// Версия 4
// сохраняет локальное форматирование текста после импорта из Word, преобразуя его в стили символов
// убирает цвета не в цветовой модели CMYK 
// убирает импортированные стили
// добавляет неразрываемый пробел (Non-breaking space) некоторым елементам в тексте Например: В, У, гг., млрд.
// убирает лишние пробелы, производит поиск-замену некоторых некоторых сочетаний Например: "--" на "—"
// удаление гиперссылки
// Copyright © 2008 Kasyan Servetsky

#target indesign
if (app.documents.length == 0) {
	alert("У вас не открыто ни одиного документа.", "Ошибка", true);
}
else {
	app.activate();
	var myDoc = app.activeDocument;
	if (myDoc.selection.length == 1) {
		if (myDoc.selection[0].constructor.name ==  "TextFrame") {
		var myTextFrame = myDoc.selection[0];
		}
		else {
			alert("Для правильной работы скрипта необходимо выделить текстовый фрейм ЧЕРНОЙ СТРЕЛКОЙ.", "Ошибка", true);
			exit();
		}
	}
	else {
		alert("Для правильной работы скрипта необходимо выделить один текстовый фрейм черной стрелкой.", "Ошибка", true);
		exit();
	}
	if (!myDoc.saved) {
		alert("Документ ещё ни разу не был сохранён, сохраните и попробуйте снова.", "Ошибка", true);
		exit();
	}
//--------------------------------- Progressbar ---------------------------------
	var stop = 11;
	var w = new Window ( 'window', 'Подготовка файла', undefined, {closeButton:false, maximizeButton:false, minimizeButton:false} ); 
	var pb = w.add ('progressbar', [0, 0, 350, 20], 0, stop); 
	var txt = w.add('statictext', undefined, 'Начало процесса');
	txt.alignment = "fill";
	w.show();
	pb.value = 1;
	var myTxtReplace;
	var myGrpReplace;
	myReplaceStuff();
	txt.text = "Поиск-замена фрагментов текста";
	myProblems = 0;
	myReplaceNonCMYK();
	pb.value = 2;
	txt.text = "Удаление цветов не в CMYK";
//---------------------convertBulletsAndNumberingToText-------------------
	var myStory = myTextFrame.parentStory;
	myStory.convertBulletsAndNumberingToText ();
//---------------------------------------------------------------------------------------
var myStyleNames = myDoc.paragraphStyles.everyItem().name;
//alert(myStyleNames);
	
	if (app.activeDocument.paragraphStyles.item("Body Text") == null) {
		pb.value = 3;
		txt.text = "Создание стиля абзаца \"Body Text\"";
		
		var paraStyle = myDoc.paragraphStyles.add({name:"Body Text"});
		// paraStyle.name = "Body Text";
		paraStyle.basedOn = myDoc.paragraphStyles.item(0);
		paraStyle.appliedFont = "Minion Pro";
		try{
			fontStyle = "Regular";
		}
		catch(e){}
		try {
		paraStyle.composer = "Adobe Paragraph Composer";
		}
		catch(e) {			
			paraStyle.composer = "Компоновщик абзацев Adobe";
		}
		paraStyle.pointSize = 10;
		paraStyle.horizontalScale = 100;
		paraStyle.firstLineIndent = paraStyle.pointSize *1,5;
		paraStyle.alignToBaseline= false;
		paraStyle.leftIndent = 0;
		paraStyle.rightIndent = 0;
		paraStyle.spaceBefore =0;
		paraStyle.spaceAfter =0;
		paraStyle.justification = Justification.LEFT_JUSTIFIED
		//paraStyle.justification = Justification.leftAlign;
		paraStyle.leading =12;
		try{
		paraStyle.kerningMethod = "Metrics";
		}
		catch(e){
			paraStyle.kerningMethod = "Метрич.";
			}
		paraStyle.tracking =0;
		paraStyle.hyphenateCapitalizedWords = true;
		paraStyle.hyphenation=true;
		paraStyle.hyphenateBeforeLast= 2;
		paraStyle.hyphenateAfterFirst= 2;
		paraStyle.hyphenateWordsLongerThan= 5;
		paraStyle.hyphenateLadderLimit=3;
		paraStyle.hyphenationZone=12.7;
		paraStyle.hyphenWeight = 5;
		try {
			paraStyle.appliedLanguage= "Russian";
		}
		catch(e){
			paraStyle.appliedLanguage = "Русский";
		}
		paraStyle.fillColor= "Black"
		//paraStyle.fillColor = app.colors.item("Black");
		////////// Justification /////////
		paraStyle.desiredGlyphScaling = 100;
		paraStyle.desiredLetterSpacing = 0;
		paraStyle.desiredWordSpacing = 100;
		paraStyle.maximumGlyphScaling = 102;
		paraStyle.maximumLetterSpacing = 0;
		paraStyle.maximumWordSpacing = 130;
		paraStyle.minimumGlyphScaling = 98;
		paraStyle.minimumLetterSpacing = 0;
		paraStyle.minimumWordSpacing = 80;
		paraStyle.ruleAbove = false;
		paraStyle.ruleBelow = false;
	}
/*
		var paraStyle = myDoc.paragraphStyles.add( {	
																		basedOn:"[No Paragraph Style]",
																				name:"Body Text",
																				alignToBaseline:true,
																				firstLineIndent:2,
																				leftIndent:0,
																				rightIndent:0,
																				spaceBefore:0,
																				spaceAfter:0,
																				justification:Justification.LEFT_JUSTIFIED,
																				appliedFont:app.fonts.item("Minion Pro"),
																				// appliedFont:"TimesPalKasN\tRegular",
																				pointSize:8.5,
																				leading:10.6,
																				kerningMethod:"Metrics",
																				tracking:0,
																				hyphenateCapitalizedWords:true,
																				hyphenation:true,
																				hyphenateBeforeLast:2,
																				hyphenateAfterFirst:2,
																				hyphenateWordsLongerThan:5,
																				hyphenateLadderLimit:3,
																				hyphenationZone:12.7,
																				hyphenWeight:5,
																				appliedLanguage:"Russian",
																				fillColor:"Black"} );
	}*/
	else {
		var paraStyle = myDoc.paragraphStyles.item("Body Text");
		pb.value = 3;
	}

	removeImportedStyles();
	pb.value = 4;
	txt.text = "Удаление импортированных стилей";
	protectLocalStyling();
	pb.value = 5;
	txt.text = "Сохранение выделений";
	myTextFrame.parentStory.texts.everyItem().paragraphs.everyItem().applyParagraphStyle(paraStyle, true);
	pb.value = 6;
	txt.text = "Применение стиля абзаца \"Body Text\"";
	removeInTables();
	pb.value = 7;
	txt.text = "Обработка таблиц";
	myTextFrame.parentStory.texts.everyItem().paragraphs.everyItem().clearOverrides(OverrideType.all); // ***
	pb.value = 8;
	txt.text = "Удаление локального форматирования";
	replaceTxt();
	pb.value = 9;
	txt.text = "Замена текста";
	replaceGrep();
	pb.value = 10;
	myRemoveHyperLinks();
	pb.value = 11;
	txt.text = "Удаление гиперссылок";
	w.hide();
	
	if (myProblems == 0) {
		alert ("Проблем не обнаружено.", "Всё готово");
	}
	else {
		alert ("Проблемы были обнаружены и исправлены.", "Всё готово");
	}
}
//************************************** Функции *******************************************************
function protectLocalStyling() { 
    var myStyles = ["Italic","Bold", "Bold Italic"]; 
    var myPosns = ["superscript","subscript"]; 
    var myPosnEnums = [Position.superscript, Position.subscript];
	var noCharStyle = myDoc.characterStyles[0];
    for (var j = myStyles.length - 1; j >= 0; j--) { 
      var myCharStyle = myDoc.characterStyles.item(myStyles[j]); 
      if (myCharStyle == null) { 
        var myCharStyle = myDoc.characterStyles.add({name:myStyles[j], fontStyle:myStyles[j]}); 
      }
		app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
		app.findTextPreferences.appliedCharacterStyle = noCharStyle;
		app.findTextPreferences.fontStyle = myStyles[j];
		app.changeTextPreferences.appliedCharacterStyle = myStyles[j];
		myTextFrame.parentStory.changeText();
    } 
    for (var j = myPosns.length - 1; j >= 0; j--) { 
      var myPosCharStyle = myDoc.characterStyles.item(myPosns[j]); 
      if (myPosCharStyle == null) { 
        var myPosCharStyle = myDoc.characterStyles.add({name:myPosns[j], position:myPosnEnums[j]}); 
      } 
		app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
		app.findTextPreferences.appliedCharacterStyle = noCharStyle;
		app.findTextPreferences.position = Position[myPosns[j]];
		app.changeTextPreferences.appliedCharacterStyle = myPosns[j];
		myTextFrame.parentStory.changeText();
	} 
	app.findTextPreferences = app.changeTextPreferences = NothingEnum.nothing;
} 
//  Убираем цвета не в цветовой модели CMYK 
function myReplaceNonCMYK(){
	for(var myCounter = myDoc.colors.length; myCounter > 0; myCounter--){
		if (myDoc.colors[myCounter-1].name != "Registration" && myDoc.colors[myCounter-1].name != "Paper" && myDoc.colors[myCounter-1].name != "Cyan" && myDoc.colors[myCounter-1].name != "Magenta" && myDoc.colors[myCounter-1].name != "Yellow" && myDoc.colors[myCounter-1].name != "Black") {
			if ((myDoc.colors[myCounter-1].space != ColorSpace.cmyk)  || (myDoc.colors[myCounter-1].model != ColorModel.process)){
				myProblems = myProblems + 1;
				myDoc.colors[myCounter-1].remove ("Black")
			}
		}
	}
}
// Убираем импортированные стили
function removeImportedStyles(){ 
	var paraStyle = myDoc.paragraphStyles.item("Body Text");
	var noneCharaStyle = myDoc.characterStyles[0];

	for(var myCounter = myDoc.paragraphStyles.length-1; myCounter >= 2; myCounter--){
		if (myDoc.paragraphStyles[myCounter].imported == true ) {
			myDoc.paragraphStyles[myCounter].remove(paraStyle);
		}
	} 

	for(var myCounter = myDoc.characterStyles.length-1; myCounter >= 2; myCounter--){
		if (myDoc.characterStyles[myCounter].imported == true) {
			myDoc.characterStyles[myCounter].remove(noneCharaStyle);
		}
	}
}
// Обработка таблиц
function removeInTables(){
	if (myTextFrame.parentStory.texts.everyItem().tables.length > 0) {
		if (myDoc.paragraphStyles.item("Table Text") == null) {
			myTableStyle = myDoc.paragraphStyles.add({name:"Table Text", appliedFont:"Minion Pro", pointSize:9, leading:10});
		}
		else {myTableStyle = myDoc.paragraphStyles.item("Table Text")}
	myTextFrame.parentStory.texts.everyItem().tables.everyItem().cells.everyItem().paragraphs.everyItem().applyParagraphStyle(myTableStyle, true);
	myTextFrame.parentStory.texts.everyItem().tables.everyItem().cells.everyItem().paragraphs.everyItem().clearOverrides(OverrideType.all);
	}
}
// Параметры поиска-замены
function myReplaceStuff() {
	myTxtReplace =	[
								[" А ", " А^S"],
								[" В ", " В^S"],
								[" С ", " С^S"],
								[" К ", " К^S"],
								[" О ", " О^S"],
								[" У ", " У^S"],
								[" На ", " На^S"],
								[" По ", " По^S"],
								[" Из ", " Из^S"],
								["г-н ", "г-н^S"],
								["г-на ", "г-на^S"],
								["г-ну ", "г-ну^S"],
								[" т", " ^Sт"],
								[" г.", " ^Sг."],
								[" гг.", " ^Sгг."],
								[" грн.", " ^Sгрн."],
								[" коп.", " ^Sкоп."],
								[" тыс", " ^Sтыс"],
								[" млн", " ^Sмлн"],
								[" млрд", " ^Sмлрд"],
								[" т.п.", " ^Sт.п."],
								[" т.д.", " ^Sт.д."],
								[" др.", " ^Sдр."],
								[" км", " ^Sкм"],
								["см. стр.", "см.^Sстр."],
								[" ^p", "^p"],
								[" —", "^S—"],
								[" —", "^S—"],
								["№ ", "№"],
								["$ ", "$"],
								["EUR ", "EUR"],
								[" .", "."],
								[" ,", ","],
								[" …", "…"],
								["...", "…"],
								[" ?", "?"],
								[" )", ")"],
								["( ", "("],
								["«", "“"],
								["»", "”"],
								]
								
	myGrpReplace =	[
								["[~m~>~f~|~S~s~<~/~.~3~4~% ]{2,}", " "], // Multiple Space to Single Space
								["~b~b+", "\\r"], // Multiple Return to Single Return
								["--", "~_"] // Dash Dash to Em-dash 
							]
								//["~b~b+", "\\r"], Multiple Return to Single Return
}
function replaceTxt() {
	app.findTextPreferences = NothingEnum.nothing;
	app.changeTextPreferences = NothingEnum.nothing;
	app.findChangeTextOptions.wholeWord = false;
	app.findChangeTextOptions.caseSensitive = true;
	app.findChangeTextOptions.includeMasterPages = false;
	for (i = 0; i <  myTxtReplace.length; i++) {
		var myCurArray = myTxtReplace[i];
		app.findTextPreferences.findWhat = myCurArray[0];
		app.changeTextPreferences.changeTo = myCurArray[1]; 
		myTextFrame.parentStory.changeText();
	}
	app.findTextPreferences = NothingEnum.nothing;
	app.changeTextPreferences = NothingEnum.nothing;
}
function replaceGrep() {
	app.findGrepPreferences = NothingEnum.nothing;
	app.changeGrepPreferences = NothingEnum.nothing;
	for (i = 0; i <  myGrpReplace.length; i++) {
		var myCurArray = myGrpReplace[i];
		app.findGrepPreferences.findWhat = myCurArray[0];
		app.changeGrepPreferences.changeTo = myCurArray[1]; 
		myTextFrame.parentStory.changeGrep();
	}
	app.findGrepPreferences = NothingEnum.nothing;
	app.changeGrepPreferences = NothingEnum.nothing;
}
function myRemoveHyperLinks(){
	if (myDoc.hyperlinks.length > 0){
		for(var myCounter = myDoc.hyperlinks.length; myCounter > 0 ; myCounter--){
			myProblems++;
			myDoc.hyperlinks[myCounter - 1].remove();
		}
	}
}